pcl::VoxelGridCovariance< PointT >::Leaf Struct Reference

Simple structure to hold a centroid, covarince and the number of points in a leaf. More...

`#include <pcl/filters/voxel_grid_covariance.h>`

## Public Member Functions

| Leaf ()
| Constructor. More...
Eigen::Matrix3d | getCov () const
| Get the voxel covariance. More...
Eigen::Matrix3d | getInverseCov () const
| Get the inverse of the voxel covariance. More...
Eigen::Vector3d | getMean () const
| Get the voxel centroid. More...
Eigen::Matrix3d | getEvecs () const
| Get the eigen vectors of the voxel covariance. More...
Eigen::Vector3d | getEvals () const
| Get the eigen values of the voxel covariance. More...
int | getPointCount () const
| Get the number of points contained by this voxel. More...

## Public Attributes

int | nr_points
| Number of points contained by voxel. More...
Eigen::Vector3d | mean_
| 3D voxel centroid More...
Eigen::VectorXf | centroid
| Nd voxel centroid. More...
Eigen::Matrix3d | cov_
| Voxel covariance matrix. More...
Eigen::Matrix3d | icov_
| Inverse of voxel covariance matrix. More...
Eigen::Matrix3d | evecs_
| Eigen vectors of voxel covariance matrix. More...
Eigen::Vector3d | evals_
| Eigen values of voxel covariance matrix. More...

## Detailed Description

### template<typename PointT>
struct pcl::VoxelGridCovariance< PointT >::Leaf

Simple structure to hold a centroid, covarince and the number of points in a leaf.

Inverse covariance, eigen vectors and engen values are precomputed.

Definition at line 93 of file voxel_grid_covariance.h.

## Constructor & Destructor Documentation

## Leaf()

template<typename PointT>

pcl::VoxelGridCovariance< PointT >::Leaf::Leaf | ( |  | ) |

inline

Constructor.

Sets nr_points, icov_, mean_ and evals_ to 0 and cov_ and evecs_ to the identity matrix

Definition at line 98 of file voxel_grid_covariance.h.

## Member Function Documentation

## getCov()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getCov | ( |  | ) | const

inline

Get the voxel covariance.

Returns
  covariance matrix

Definition at line 113 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::cov_.

## getEvals()

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::getEvals | ( |  | ) | const

inline

Get the eigen values of the voxel covariance.

Note
  Order corresponds with getEvecs

Returns
  vector of eigen values

Definition at line 151 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::evals_.

## getEvecs()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getEvecs | ( |  | ) | const

inline

Get the eigen vectors of the voxel covariance.

Note
  Order corresponds with getEvals

Returns
  matrix whose columns contain eigen vectors

Definition at line 141 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::evecs_.

## getInverseCov()

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::getInverseCov | ( |  | ) | const

inline

Get the inverse of the voxel covariance.

Returns
  inverse covariance matrix

Definition at line 122 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::icov_.

## getMean()

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::getMean | ( |  | ) | const

inline

Get the voxel centroid.

Returns
  centroid

Definition at line 131 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::mean_.

## getPointCount()

template<typename PointT>

int pcl::VoxelGridCovariance< PointT >::Leaf::getPointCount | ( |  | ) | const

inline

Get the number of points contained by this voxel.

Returns
  number of points

Definition at line 160 of file voxel_grid_covariance.h.

References pcl::VoxelGridCovariance< PointT >::Leaf::nr_points.

## Member Data Documentation

## centroid

template<typename PointT>

Eigen::VectorXf pcl::VoxelGridCovariance< PointT >::Leaf::centroid

Nd voxel centroid.

Note
  Differs from mean_ when color data is used

Definition at line 174 of file voxel_grid_covariance.h.

## cov_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::cov_

Voxel covariance matrix.

Definition at line 177 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getCov().

## evals_

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::evals_

Eigen values of voxel covariance matrix.

Definition at line 186 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getEvals().

## evecs_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::evecs_

Eigen vectors of voxel covariance matrix.

Definition at line 183 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getEvecs().

## icov_

template<typename PointT>

Eigen::Matrix3d pcl::VoxelGridCovariance< PointT >::Leaf::icov_

Inverse of voxel covariance matrix.

Definition at line 180 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getInverseCov().

## mean_

template<typename PointT>

Eigen::Vector3d pcl::VoxelGridCovariance< PointT >::Leaf::mean_

3D voxel centroid

Definition at line 169 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getMean().

## nr_points

template<typename PointT>

int pcl::VoxelGridCovariance< PointT >::Leaf::nr_points

Number of points contained by voxel.

Definition at line 166 of file voxel_grid_covariance.h.

Referenced by pcl::VoxelGridCovariance< PointT >::Leaf::getPointCount().

The documentation for this struct was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/filters/include/pcl/filters/voxel_grid_covariance.h